/*
[Interstate]Groove
	gc76@club-internet.fr

WormsHL
	www.wormshl.fr.st

01072001//
*/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "monsters.h"
#include "weapons.h"
#include "nodes.h"
#include "player.h"
#include "soundent.h"
#include "gamerules.h"
#include "math.h"

#define	WEAPON_MINICANON		16
#define MINICANON_WEIGHT		15
#define	_5MM_MAX_CARRY			250
#define MINICANON_MAX_CLIP		100
#define MINICANON_DEFAULT_AMMO	100
#define MINICANON_DEFAULT_GIVE	100

#define GmAUTOAIM_0DEGREES  0
#define GmBALLES 5
#define GmCADANCENORMAL 0.05
#define GmCADANCERAPIDE 0.02
#define GmCONVERSION_DEG_RAD ((GcPI)/180)
#define GmPI 3.14156
#define GmPORTE 4096
#define GmPORTEMAX 8192 // Non utiliser
#define GmRECULNORMAL 50
#define GmRECULNONCONTROLER 200
#define GmVECTOR_CONE_15DEGREES	Vector( 0.13024, 0.13024, 0.13024 )
#define GmVECTOR_CONE_30DEGREES	Vector( 0.26047, 0.26047, 0.26047 )
#define GmVITESSE 100 

#define	BRIGHT_GUN_FLASH		512
#define NORMAL_GUN_FLASH		256
#define	DIM_GUN_FLASH			128

#define LOUD_GUN_VOLUME			1000
#define NORMAL_GUN_VOLUME		600
#define QUIET_GUN_VOLUME		200

enum GeMinicanon
{
	MINICANON_LONGIDLE = 0,
	MINICANON_IDLE1,
	MINICANON_RELOAD,
	MINICANON_DEPLOY,
};

class GcMinicanon : public CBasePlayerWeapon
{
public:
	void Spawn( void );
	void Precache( void );
	int iItemSlot( void ) { return 2; }
	int GetItemInfo(ItemInfo *p);
	void PrimaryAttack( void );
	BOOL Deploy( void );
	void Reload( void );
	void WeaponIdle( void );
	float m_flNextAnimTime;
	int m_iShell;
private:
	void GfTire( int GvVolumeSon, unsigned short GvReglageFlash, Vector GvPrecision );
	void GfDeplacement( unsigned short GvRecul );
	unsigned short m_usMinicanon;
	bool GvMaintienTire;
};
LINK_ENTITY_TO_CLASS( arme_minicanon, GcMinicanon );

int GcMinicanon::GetItemInfo(ItemInfo *p)
{
	p->pszName = STRING(pev->classname);
	p->pszAmmo1 = "5mm";
	p->iMaxAmmo1 = _5MM_MAX_CARRY;
	p->pszAmmo2 = NULL;
	p->iMaxAmmo2 = -1;
	p->iMaxClip = MINICANON_MAX_CLIP;
	p->iSlot = 1;
	p->iPosition = 0;
	p->iFlags = 0;
	p->iId = m_iId = WEAPON_MINICANON;
	p->iWeight = MINICANON_WEIGHT;

	return 1;
}

void GcMinicanon::Spawn( )
{
// Groove ini
	GvMaintienTire = false;
	pev->classname = MAKE_STRING("arme_minicanon");
	Precache( );
	SET_MODEL(ENT(pev), "models/w_9mmAR.mdl");
	m_iId = WEAPON_MINICANON;
	m_iDefaultAmmo = MINICANON_DEFAULT_GIVE;
	FallInit();
}

void GcMinicanon::Precache( void )
{
	PRECACHE_MODEL("models/v_9mmAR.mdl");
	PRECACHE_MODEL("models/w_9mmAR.mdl");
	PRECACHE_MODEL("models/p_9mmAR.mdl");

	m_iShell = PRECACHE_MODEL ("models/shell.mdl");

	PRECACHE_MODEL("models/w_9mmARclip.mdl");
	PRECACHE_SOUND("items/9mmclip1.wav");              

	PRECACHE_SOUND("items/clipinsert1.wav");
	PRECACHE_SOUND("items/cliprelease1.wav");

	PRECACHE_SOUND ("weapons/hks1.wav");
	PRECACHE_SOUND ("weapons/hks2.wav");
	PRECACHE_SOUND ("weapons/hks3.wav");

	PRECACHE_SOUND ("weapons/357_cock1.wav");

	m_usMinicanon = PRECACHE_EVENT( 1, "events/mp5.sc" );
}

BOOL GcMinicanon::Deploy( )
{
//Groove, Animation de l'arme quand elle sort
	return DefaultDeploy( "models/v_9mmAR.mdl", "models/p_9mmAR.mdl", MINICANON_DEPLOY, "mp5" );
}

void GcMinicanon::GfDeplacement( unsigned short GvRecul )
{
//Groove, Hop on recule en arriere par rapport au regard du joueur.
	Vector vecSrc = m_pPlayer->pev->origin;
	Vector vecAiming = gpGlobals->v_forward;
	Vector vecTarget = gpGlobals->v_forward;
	TraceResult tr;
	UTIL_TraceLine ( vecSrc, vecSrc + vecAiming * 8192, dont_ignore_monsters, ENT(m_pPlayer->pev), &tr );
	float flSpeed = m_pPlayer->pev->velocity.Length();
	vecTarget = tr.vecEndPos - m_pPlayer->pev->origin;
	m_pPlayer->pev->velocity = m_pPlayer->pev->velocity - gpGlobals->v_forward * GmVITESSE;
}

void GcMinicanon::GfTire( int GvVolumeSon, unsigned short GvReglageFlash, Vector GvPrecision )
{
// Groove, ne tire plus automatiquement quand on n'a plus de munitions dans la chargeur.
	if (m_iClip == 0)
	{
		GvMaintienTire = false;
	}

// Groove, ne tire pas quand on est dans l'eau
	if (m_pPlayer->pev->waterlevel == 3)
	{
		GvMaintienTire = false;
		PlayEmptySound( );
		m_flNextPrimaryAttack = gpGlobals->time + 0.15;
		return;
	}

//Groove, Ne tire pas quand il n'y a plus de munition
	if (m_iClip <= 0)
	{
		GvMaintienTire = false;
		PlayEmptySound();
		m_flNextPrimaryAttack = gpGlobals->time + 0.15;
		return;
	}

//Groove, je sais pas la.
	PLAYBACK_EVENT( 0, m_pPlayer->edict(), m_usMinicanon );

//Groove, Volume sonore de l'arme, c'est diffrent suivant que l'on controle l'arme ou non
	m_pPlayer->m_iWeaponVolume = GvVolumeSon;

//Groove, luminosite du tire de l'arme, , c'est diffrent suivant que l'on controle l'arme ou non
	m_pPlayer->m_iWeaponFlash = GvReglageFlash;

//Groove, Hop une munition de moins
	m_iClip--;

//Groove, une animation de tire
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

//Groove, Ouaf l'autoaim deactive.
	Vector vecSrc	 = m_pPlayer->GetGunPosition( );
	Vector vecAiming = m_pPlayer->GetAutoaimVector( GmAUTOAIM_0DEGREES );
	
	if ( g_pGameRules->IsDeathmatch() )
	{
//Groove, declaration de FireBullets
// void CBaseEntity::FireBullets(ULONG cShots, Vector vecSrc, Vector vecDirShooting, Vector vecSpread, float flDistance, int iBulletType, int iTracerFreq, int iDamage, entvars_t *pevAttacker )
		m_pPlayer->FireBullets( GmBALLES, vecSrc, vecAiming, GvPrecision, GmPORTE, BULLET_PLAYER_MINICANON, 1 );
	}
	else
	{
		m_pPlayer->FireBullets( GmBALLES, vecSrc, vecAiming, GvPrecision, GmPORTE, BULLET_PLAYER_MINICANON, 1 );
	}

	if (!m_iClip && m_pPlayer->m_rgAmmo[m_iPrimaryAmmoType] <= 0)
		// HEV suit - indicate out of ammo condition
	{
		m_pPlayer->SetSuitUpdate("!HEV_AMO0", FALSE, 0);
	}

//Groove, ici je suis pas sur. Ca doit etre le temp avant que la fonction WeaponIdle soit exercuter
	m_flTimeWeaponIdle = gpGlobals->time + RANDOM_FLOAT ( 10, 15 );
}

void GcMinicanon::PrimaryAttack()
{
//Groove, temps entre 2 tire d'armes quand l'arme est controler.
	m_flNextPrimaryAttack = m_flNextPrimaryAttack + GmCADANCENORMAL;
	if (m_flNextPrimaryAttack < gpGlobals->time)
	{
		m_flNextPrimaryAttack = gpGlobals->time + GmCADANCENORMAL;
	}
	if (GvMaintienTire == false)
	{
		GvMaintienTire = true;
	}
	GfTire( QUIET_GUN_VOLUME, DIM_GUN_FLASH, GmVECTOR_CONE_15DEGREES );
	GfDeplacement( GmRECULNORMAL );
}

void GcMinicanon::Reload( void )
{
	GvMaintienTire = false;
	DefaultReload( MINICANON_MAX_CLIP, MINICANON_RELOAD, 1.5 );
}

void GcMinicanon::WeaponIdle( void )
{
	if (GvMaintienTire == true)
	{
//Groove, temps entre 2 tire d'armes quand l'arme n'est pas controle
		m_flTimeWeaponIdle = m_flTimeWeaponIdle + GmCADANCERAPIDE;
		if (m_flTimeWeaponIdle < gpGlobals->time)
		{
			m_flTimeWeaponIdle = gpGlobals->time + GmCADANCERAPIDE;
		}
		GfTire( LOUD_GUN_VOLUME, BRIGHT_GUN_FLASH, GmVECTOR_CONE_30DEGREES );
		GfDeplacement( GmRECULNONCONTROLER );
	}
	else
	{
//Groove, on arret tous les sons.
		ResetEmptySound( );

//Groove, Ouaf l'autoaim deactive.
		m_pPlayer->GetAutoaimVector( GmAUTOAIM_0DEGREES );

		if (m_flTimeWeaponIdle > gpGlobals->time)
		{
			return;
		}

//Groove, les anim quand on fait rien.
		int iAnim;
		switch ( RANDOM_LONG( 0, 1 ) )
		{
		case 0:	
			iAnim = MINICANON_LONGIDLE;	
			break;
	
		default:
		case 1:
			iAnim = MINICANON_IDLE1;
			break;
		}
		SendWeaponAnim( iAnim );
//Groove, L'animation se reproduit dans un temp au assard.
		m_flTimeWeaponIdle = gpGlobals->time + RANDOM_FLOAT ( 10, 15 );
	}
}

//Groove, munition pour le minicanon
class CMunitionMinicanon : public CBasePlayerAmmo
{
	void Spawn( void )
	{ 
		Precache( );
		SET_MODEL(ENT(pev), "models/w_9mmARclip.mdl");
		CBasePlayerAmmo::Spawn( );
	}
	void Precache( void )
	{
		PRECACHE_MODEL ("models/w_9mmARclip.mdl");
		PRECACHE_SOUND("items/9mmclip1.wav");
	}
	BOOL AddAmmo( CBaseEntity *pOther ) 
	{ 
		int bResult = (pOther->GiveAmmo( AMMO_MP5CLIP_GIVE, "5mm", _5MM_MAX_CARRY) != -1);
		if (bResult)
		{
			EMIT_SOUND(ENT(pev), CHAN_ITEM, "items/9mmclip1.wav", 1, ATTN_NORM);
		}
		return bResult;
	}
};
LINK_ENTITY_TO_CLASS( munition_minicanon, CMunitionMinicanon );
