/***
*
*	Une gr pour WHL
*
****/
#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "monsters.h"
#include "weapons.h"
#include "nodes.h"
#include "player.h"
#include "jet.h"


#define	CLUSTERGRENADE_PRIMARY_VOLUME		450
#define WEAPON_CLUSTERGRENADE	17
#define CLUSTERGRENADE_DEFAULT_GIVE	2
#define CLUSTERGRENADE_MAX_CARRY	10
#define CLUSTERGRENADE_WEIGHT		0
#define CLUSTER_DEGAT			100

class CClusterGrenade : public CJet
{
public:
	void Spawn( void );
	void Precache( void );
	int iItemSlot( void ) { return 5; }
	int GetItemInfo(ItemInfo *p);

	virtual void Action ( Vector vec1, Vector vec2 );
	virtual BOOL Deploy( void );
	void Holster( int skiplocal = 0 );
};
LINK_ENTITY_TO_CLASS( weapon_clustergrenade, CClusterGrenade );


void CClusterGrenade::Spawn( )
{
	Precache( );
	m_iId = WEAPON_CLUSTERGRENADE;
	SET_MODEL(ENT(pev), "models/w_grenade.mdl");

	pev->dmg = gSkillData.plrDmgHandGrenade;
	time = 3.0;

	m_iDefaultAmmo = CLUSTERGRENADE_DEFAULT_GIVE;

	FallInit();// get ready to fall down.
}


void CClusterGrenade::Precache( void )
{
	PRECACHE_MODEL("models/w_grenade.mdl");
	PRECACHE_MODEL("models/v_grenade.mdl");
	PRECACHE_MODEL("models/p_grenade.mdl");
}

int CClusterGrenade::GetItemInfo(ItemInfo *p)
{
	p->pszName = STRING(pev->classname);
	p->pszAmmo1 = "Cluster Grenade";
	p->iMaxAmmo1 = CLUSTERGRENADE_MAX_CARRY;
	p->pszAmmo2 = NULL;
	p->iMaxAmmo2 = -1;
	p->iMaxClip = WEAPON_NOCLIP;
	p->iSlot = 4;
	p->iPosition = 4;
	p->iId = m_iId = WEAPON_CLUSTERGRENADE;
	p->iWeight = CLUSTERGRENADE_WEIGHT;
	p->iFlags = ITEM_FLAG_LIMITINWORLD | ITEM_FLAG_EXHAUSTIBLE;

	return 1;
}


BOOL CClusterGrenade::Deploy( )
{
	m_flReleaseThrow = -1;
	return DefaultDeploy( "models/v_grenade.mdl", "models/p_grenade.mdl", JET_DRAW, "crowbar" );
}

void CClusterGrenade::Holster( int skiplocal /* = 0 */ )
{
	m_pPlayer->m_flNextAttack = UTIL_WeaponTimeBase() + 0.5;
	if (m_pPlayer->m_rgAmmo[m_iPrimaryAmmoType])
	{
		SendWeaponAnim( JET_HOLSTER );
	}
	else
	{
		// no more grenades!
		m_pPlayer->pev->weapons &= ~(1<<WEAPON_CLUSTERGRENADE);
		SetThink( &CClusterGrenade::DestroyItem );
		pev->nextthink = gpGlobals->time + 0.1;
	}

	EMIT_SOUND(ENT(m_pPlayer->pev), CHAN_WEAPON, "common/null.wav", 1.0, ATTN_NORM);
}

void CClusterGrenade::Action( Vector vec1, Vector vec2 )
{
	CGrenade::ShootTimedCluster( m_pPlayer->pev, vec1, vec2, time );
}
void CJet :: findetour(void)
{
m_pPlayer->m_iClientFindetour =0;
m_pPlayer->m_iClienttire=1;}
