/*Code pour afficher un sol de feu pour le mod WORMSHL
/cod par The Dude
/09/05/01
/*/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "monsters.h"
#include "weapons.h"
#include "nodes.h"
#include "player.h"
#include "pm_defs.h"
#include "decals.h"
#include "soundent.h"
#include "shake.h"
#include "effects.h"
#include "const.h"
#include "customentity.h"
#include "func_break.h"
#include "firefloor.h"

#define FIRE_SPRITE "sprites/fire.spr"


class CCFireFloor : public CFireFloor
{
	public:
	void Spawn( void );
	void Precache ( void );
	void EXPORT MyTouch( CBaseEntity* );
	void EXPORT tj();

	static CFireFloor *CreateFireFloor( Vector vecOrigin, Vector vecAngles);

private :
	//CBeam    *m_pBeam;
	//CBeam    *m_pNoise;
	CSprite    *m_pSprite;
	CBasePlayerWeapon *m_pLauncher;
	float		DeathTimer;

};

LINK_ENTITY_TO_CLASS( flamme_touch, CFireFloor );

void CFireFloor::Spawn( )
{
	Precache( );
	DeathTimer = 0;

	UTIL_SetOrigin( pev, pev->origin );
	UTIL_SetSize( pev, Vector(-16,-16,0), Vector(16,16,64) );

	m_pSprite = CSprite::SpriteCreate( FIRE_SPRITE, pev->origin, FALSE );
	m_pSprite->pev->scale = 1.0;
	m_pSprite->SetTransparency( kRenderGlow, 255, 255, 255, 255,kRenderFxNoDissipation );
	m_pSprite->pev->spawnflags |= SF_SPRITE_TEMPORARY ;

	SetThink(tj);
	pev->nextthink = gpGlobals->time + 0.1;

	m_pSprite->pev->movetype = MOVETYPE_TOSS;
	m_pSprite->pev->gravity = 0.5;
	m_pSprite->pev->solid = SOLID_NOT;// a changer

}


void CFireFloor::Precache( )
{
	PRECACHE_MODEL(FIRE_SPRITE);
}

void CFireFloor :: MyTouch( CBaseEntity* Player =NULL)
{
}


void CFireFloor :: tj( )
{
	
	SetThink(tj);
	pev->nextthink = gpGlobals->time + 0.1;
	
	
	DeathTimer +=0.1;
	if (DeathTimer <= 8)
	{
		m_pSprite->pev->frame = ((int)m_pSprite->pev->frame + 1) % 15;

		CBaseEntity *pEntity = NULL;
		while ((pEntity = UTIL_FindEntityInSphere( pEntity, pev->origin, 20 )) !=NULL)
		{
			if (FClassnameIs( pEntity->pev, "player"))
			{
				pEntity->pev->health -=1;
				pEntity->pev->velocity = gpGlobals->v_forward * 400; // vitesse fois mille
				pEntity->pev->velocity.z =pEntity->pev->velocity.y + 150; // z designe vers le haut +300!
			}
		}
	}
	else
	{
		UTIL_Remove( m_pSprite );
		m_pSprite = NULL;
	}
}


CFireFloor *CFireFloor::CreateFireFloor( Vector vecOrigin, Vector vecAngles)
{
	CFireFloor *pFFloor = GetClassPtr( (CFireFloor *)NULL );
	UTIL_SetOrigin( pFFloor->pev, vecOrigin );
	pFFloor->pev->angles = vecAngles;
	pFFloor->Spawn();
	pFFloor->pev->classname = MAKE_STRING("firefloor");
	
	return pFFloor;
}
