#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "weapons.h"
#include "player.h"
#include "soundent.h"
#include "gamerules.h"
#include "animation.h"
#include "object.h"

extern int gmsgItemPickup;

enum Object_Animations
 {
 IDLE = 1
 };

void CObject::Spawn ( void )
{
Precache( );
SET_MODEL(ENT(pev), "models/can.mdl");

pev->movetype = MOVETYPE_TOSS;
pev->solid = SOLID_TRIGGER;
UTIL_SetOrigin( pev, pev->origin );
UTIL_SetSize(pev, Vector(-16, -16, 0), Vector(16, 16, 16));

SetThink( Think );
SetTouch( Touch );

pev->sequence = IDLE;
pev->framerate = 1.0;

pev->nextthink = gpGlobals->time + 0.1;
}


void CObject::Precache( )
{
PRECACHE_MODEL( "models/can.mdl" );
}


void CObject::Materialize( void )
{
if ( pev->effects & EF_NODRAW )
 {
 pev->effects &= ~EF_NODRAW;
 pev->effects |= EF_MUZZLEFLASH;
 }
SetTouch( Touch );
SetThink( Think );
}


void CObject::Touch( CBaseEntity *pOther )
{
if ( !pOther->IsPlayer() )
 return;

CBasePlayer *pPlayer = (CBasePlayer *)pOther;
if (MyTouch( pPlayer ))
 {
 SUB_UseTargets( pOther, USE_TOGGLE, 0 );
 SetTouch( NULL );
 SetThink( NULL );
 pev->effects |= EF_NODRAW;
 }
}
BOOL CObject::MyTouch( CBasePlayer *pPlayer )
{
char text[256];
CBaseEntity *pEnt;

if ( ( pPlayer->pev->weapons & (1<< WEAPON_SUIT) ) )
 {
 if(pPlayer->HasObject)
  return FALSE;
 pPlayer->HasObject = TRUE;
 CBaseEntity *pEnt = CBaseEntity::Create( "object_follow", pev->origin,
pev->angles, pPlayer->edict() );
 CObjectFollow *pFollow = (CObjectFollow *)pEnt;
 pFollow->Owner = pPlayer;

 if(FStrEq(pPlayer->m_szTeamName, "Wormsred"))
  {
  sprintf( text, "Red team has the object!\n");
  UTIL_ClientPrintAll( HUD_PRINTCENTER, text );
  }
 else if(FStrEq(pPlayer->m_szTeamName, "Wormsblue"))
  {
  sprintf( text, "Blue team has the object!\n");
  UTIL_ClientPrintAll( HUD_PRINTCENTER, text );
  }

 MESSAGE_BEGIN( MSG_ONE, gmsgItemPickup, NULL, pPlayer->pev );
  WRITE_STRING( STRING(pev->classname) );
 MESSAGE_END();
 if(FallenObject)
  UTIL_Remove( this );
 return TRUE;
 }
return FALSE;
}
void CObject::Think( void )
{
pev->sequence = IDLE;
pev->nextthink = gpGlobals->time + 0.1;
}
void CObject::ReturnObject( )
{
edict_t *pFind;
CBaseEntity *pEnt;

pFind = FIND_ENTITY_BY_CLASSNAME( NULL, "object_world" );

while ( !FNullEnt( pFind ) )
 {
 CBaseEntity *pEnt = CBaseEntity::Instance( pFind );
 CObject *pObject = (CObject *)pEnt;
 pObject->Materialize( );
 pFind = FIND_ENTITY_BY_CLASSNAME( pFind, "object_world" );
 }
}
LINK_ENTITY_TO_CLASS( object_world, CObject );


void CObjectFollow::Spawn( )
{
Precache( );
UTIL_SetOrigin( pev, pev->origin );
pev->movetype = MOVETYPE_NONE;
pev->solid = SOLID_NOT;
pev->effects |= EF_NODRAW;
pev->sequence = IDLE;
pev->framerate = 1.0;
SET_MODEL(ENT(pev), "models/can.mdl");
SetThink( Think );
pev->nextthink = gpGlobals->time + 0.1;
}
void CObjectFollow::Precache( )
{
}
void CObjectFollow::Think( )
{
pev->effects &= ~EF_NODRAW;
pev->aiment = ENT(Owner->pev);
pev->movetype = MOVETYPE_FOLLOW;

if (!Owner->IsAlive())
 UTIL_Remove( this );

if ( !Owner->HasObject)
 UTIL_Remove( this );
else
 {
 pev->sequence = IDLE;
 pev->nextthink = gpGlobals->time + 0.1;
 }
}
LINK_ENTITY_TO_CLASS( object_follow, CObjectFollow );
