/*
[Interstate]Groove
	gc76@club-internet.fr
WormsHL
	www.wormshl.fr.st
17062001
*/

#if !defined( OEM_BUILD ) && !defined( HLDEMO_BUILD )

#include "extdll.h"
#include "util.h"
#include "cbase.h"////
#include "player.h"
#include "monsters.h"
#include "weapons.h"
#include "gamerules.h"
#include "math.h"

#define	JETPACK_PRIMARY_VOLUME		300
#define JETPACK_BEAM_SPRITE			"sprites/xbeam1.spr"
#define JETPACK_FLARE_SPRITE		"sprites/XSpark1.spr"
#define JETPACK_SOUND_OFF			"weapons/egon_off1.wav"
#define JETPACK_SOUND_RUN			"weapons/egon_run3.wav"
#define JETPACK_SOUND_STARTUP		"weapons/egon_windup2.wav"

#define GmPI 3.14156
#define GmCONVERSION_DEG_RAD ((GmPI)/180)
#define GmVITESSEAVTMAX 400 //Vitesse de dplacement rapide
#define GmVITESSEAVT 200	//Vitesse de dplacement lente
#define GmVITESSEHAUT 50	//Vitesse de dplacement normal vers le haut.
#define GmTEMP_SON_RUN 214	//Dur du son "egon_run3.wav"
#define GmCONSODIRECT 1		//Ne pas modifier, prsition de la consomation
#define GmCONSOREGUL 0.3	//Controle de la consomation ici
//Valeur + petite, consomation plus rapide
//Valeur + grande, consomation plus lente.

enum GeJetpack 
{
	JETPACK_IDLE1 = 0,
	JETPACK_FIDGET1,
	JETPACK_DRAW,
	JETPACK_HOLSTER
};

class CJetpack : public CBasePlayerWeapon
{

public:
	BOOL Deploy( void );
	int GetItemInfo(ItemInfo *p);
	int AddToPlayer( CBasePlayer *pPlayer );
	void Precache( void );
	void PrimaryAttack( void );
	void SecondaryAttack( void );
	void Spawn( void );
	void WeaponIdle( void );
	int iItemSlot( void ){ return 4; }

private:
	bool GfArretJetpack( void );
	void GfMarche( short GvVitesse );
	void GfStopSon( void );
	void GfUtiliserAmmo( int GvConso );
	
	bool	GvDeployer;
	bool	GvDemarrage;
	bool	GvSonDebut;
	bool	GvArret;
	float	GvVitesseCos;
	float	GvVitesseSin;
	float	GvTempsSonRun;
	float	GvDirectionR;
	short	GvDirectionD;
	short	GvRegulConso;
};
LINK_ENTITY_TO_CLASS(weapon_357, CJetpack );

int CJetpack::GetItemInfo(ItemInfo *p)
{
	p->pszName = STRING(pev->classname);
	p->pszAmmo1 = "uranium";
	p->iMaxAmmo1 = URANIUM_MAX_CARRY;
	p->pszAmmo2 = NULL;
	p->iMaxAmmo2 = -1;
	p->iMaxClip = WEAPON_NOCLIP;
	p->iFlags = 0;
	p->iSlot = 1;
	p->iPosition = 1;
	p->iId = m_iId = WEAPON_PYTHON;
	p->iWeight = PYTHON_WEIGHT;

	return 1;
}

void CJetpack::Spawn( )
{
// Groove, Jetpack son
	GvTempsSonRun = gpGlobals->time;
//	GvVitesseAvant = GmVITESSEAVTMAX;

	pev->classname = MAKE_STRING("weapon_357");
	Precache( );
	m_iId = WEAPON_PYTHON;
	m_iDefaultAmmo = PYTHON_DEFAULT_GIVE;
	SET_MODEL(ENT(pev), "models/w_egon.mdl");
	FallInit();
}

void CJetpack::Precache( void )
{
	PRECACHE_MODEL("models/w_egon.mdl");
	PRECACHE_MODEL("models/v_egon.mdl");
	PRECACHE_MODEL("models/p_egon.mdl");
	PRECACHE_MODEL( JETPACK_BEAM_SPRITE );
	PRECACHE_MODEL( JETPACK_FLARE_SPRITE );
//	PRECACHE_MODEL("models/w_9mmclip.mdl");

	PRECACHE_SOUND("items/9mmclip1.wav");
	PRECACHE_SOUND( JETPACK_SOUND_OFF );
	PRECACHE_SOUND( JETPACK_SOUND_RUN );
	PRECACHE_SOUND( JETPACK_SOUND_STARTUP );
	PRECACHE_SOUND ("weapons/357_cock1.wav");//
}

BOOL CJetpack::Deploy( void )
{
	GvDeployer = FALSE;
	return DefaultDeploy( "models/v_egon.mdl", "models/p_egon.mdl", JETPACK_DRAW, "egon" );
}

int CJetpack::AddToPlayer( CBasePlayer *pPlayer )
{
	if ( CBasePlayerWeapon::AddToPlayer( pPlayer ) )
	{
		MESSAGE_BEGIN( MSG_ONE, gmsgWeapPickup, NULL, pPlayer->pev );
		WRITE_BYTE( m_iId );
		MESSAGE_END();
		return TRUE;
	}
	return FALSE;
}

void CJetpack::GfStopSon( void )
{
	STOP_SOUND( ENT(m_pPlayer->pev), CHAN_STATIC, JETPACK_SOUND_RUN );
	STOP_SOUND( ENT(m_pPlayer->pev), CHAN_WEAPON, JETPACK_SOUND_STARTUP );
}

// Groove, Gestion de l'allumage du jetpack
bool CJetpack::GfArretJetpack( void )
{
	if ((m_pPlayer->m_rgAmmo[m_iPrimaryAmmoType] <= 0)||(m_pPlayer->pev->waterlevel == 3))
	{
		PlayEmptySound( );
		GfStopSon( );
		m_flNextPrimaryAttack = gpGlobals->time + 0.15;
		return true;
//		return false;
	}
	else
	{
		return false;
//		return true;
	}
}

void CJetpack::PrimaryAttack( void )
{if (!m_pPlayer->m_iClientFindetour)
return;
	GfMarche( GmVITESSEAVT );
}

void CJetpack::SecondaryAttack( void )
{
	GfMarche( GmVITESSEAVTMAX );
}

void CJetpack::GfMarche( short GvVitesse )
{if (!m_pPlayer->m_iClientFindetour)
return;
// Groove, controle munition, sous eau et controle jetpack
	GvArret = GfArretJetpack( );
// Groove,le jetpack en action
	if (GvArret == false)
	{
		Vector vecSrc = m_pPlayer->pev->origin;
		Vector vecAiming = gpGlobals->v_forward;
		Vector vecTarget = gpGlobals->v_forward;
		TraceResult tr;
		UTIL_TraceLine ( vecSrc, vecSrc + vecAiming * 8192, dont_ignore_monsters, ENT(m_pPlayer->pev), &tr );
		float flSpeed = m_pPlayer->pev->velocity.Length();
		vecTarget = tr.vecEndPos - m_pPlayer->pev->origin;
// Groove, Jetpack au demarrage.
		if (GvDemarrage == true)
		{
			if ( GvSonDebut == true)
			{
				EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_WEAPON, JETPACK_SOUND_STARTUP, 0.9, ATTN_NORM, 0, 100 );
				GvSonDebut = false;
			}
			GvDirectionD = GvDirectionD + 2;
			GvDirectionR = GvDirectionD * GmCONVERSION_DEG_RAD;
			GvVitesseCos = sqrtl( powl( (GvVitesse * acosl(GvDirectionR) + 1),2));
			GvVitesseSin = sqrtl( powl( (GvVitesse * asinl(GvDirectionR) + 1),2));
			if (GvDirectionD >= 85)
			{
				GvDemarrage = false;
				GvSonDebut = true;
			}
			if ((GvVitesseSin <= 0) || (GvVitesseSin >= 255))
			{
				GvVitesseSin = 200;
			}
		}
// Groove, Jetpack en fonctionnement normal.
		else
		{
			if (GvTempsSonRun <= gpGlobals->time)
			{
				EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_STATIC, JETPACK_SOUND_RUN, 0.9, ATTN_NORM, 0, 100 );
				GvTempsSonRun = gpGlobals->time + GmTEMP_SON_RUN;
			}
			if ( GvSonDebut == true)
			{
				GfStopSon();
				EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_STATIC, JETPACK_SOUND_RUN, 0.9, ATTN_NORM, 0, 100 );
				GvSonDebut = false;
			}
			GvVitesseCos = GmVITESSEHAUT;
			GvVitesseSin = GvVitesse;
		}
// Groove Consomation
		if (GvRegulConso >= (ceil((500-GvVitesse)*GmCONSOREGUL))) //Conso proporcionnel a la vitesse
		{
			GfUtiliserAmmo(GmCONSODIRECT);
			GvRegulConso = 0;
		}
		else
		{
			GvRegulConso++;
		}
// Groove vitesse en x et z
		m_pPlayer->pev->velocity = (m_pPlayer->pev->velocity * 0.2 + vecTarget *(flSpeed * 0.2 + 400)).Normalize() * GvVitesseSin;
		m_pPlayer->pev->velocity.z += GvVitesseCos;
	}
}

void CJetpack::GfUtiliserAmmo( int GvConso )
{
	if ( m_pPlayer->m_rgAmmo[m_iPrimaryAmmoType] >= GvConso )
	{
		m_pPlayer->m_rgAmmo[m_iPrimaryAmmoType] -= GvConso;
	}
	else
	{
		m_pPlayer->m_rgAmmo[m_iPrimaryAmmoType] = 0;
	}
}

void CJetpack::WeaponIdle( void )
{
// Groove ini
	GfStopSon( );
	GvArret = false;//
	GvDemarrage = true;
	GvDirectionD = 0;
	GvSonDebut = true;
	GvTempsSonRun = gpGlobals->time;
// Groove ini

	ResetEmptySound( );

	if ( m_flTimeWeaponIdle > gpGlobals->time )
	{
		return;
	}

	int iAnim;

	float flRand = RANDOM_FLOAT(0,1);

	if ( flRand <= 0.5 )
	{
		iAnim = JETPACK_IDLE1;
		m_flTimeWeaponIdle = gpGlobals->time + RANDOM_FLOAT(10,15);
	}
	else 
	{
		iAnim = JETPACK_FIDGET1;
		m_flTimeWeaponIdle = gpGlobals->time + 3;
	}

	SendWeaponAnim( iAnim );
	GvDeployer = TRUE;
}

/*class CJetpackAmmo : public CBasePlayerAmmo
{
	void Spawn( void )
	{ 
		Precache( );
		SET_MODEL(ENT(pev), "models/w_chainammo.mdl");
		CBasePlayerAmmo::Spawn( );
	}
	void Precache( void )
	{
		PRECACHE_MODEL ("models/w_chainammo.mdl");
		PRECACHE_SOUND("items/9mmclip1.wav");
	}
	BOOL AddAmmo( CBaseEntity *pOther ) 
	{ 
		if (pOther->GiveAmmo( AMMO_URANIUMBOX_GIVE, "uranium", URANIUM_MAX_CARRY ) != -1)
		{
			EMIT_SOUND(ENT(pev), CHAN_ITEM, "items/9mmclip1.wav", 1, ATTN_NORM);
			return TRUE;
		}
		return FALSE;
	}
};
LINK_ENTITY_TO_CLASS( ammo_jetpack, CJetpackAmmo );
*/
#endif

